
//-----------------------------------------------------------------------------
//	main.cpp	
//-----------------------------------------------------------------------------


#include	<windows.h>
#include	"g_tool.h"
#include	"BasicTips.h"
#include	"TextEngine.h"
#include	"main.h"
#include	"Text_Com_01.h"
#include	"Text_Com_02.h"

HWND		hwnd;		//EBhẼnh

HDC			win_hdc;	//foCXReLXgiʂ𑀍삷ƂɎg܂j
HDC			Back_DC;	//foCXReLXgiʗpj
HDC			Parts_DC;	//foCXReLXgip[cށj
HDC			BG_DC;		//foCXReLXgiwi摜j
HBITMAP		hBack_Bitmap;	//obNʖ{̂̃nh
HBITMAP		hParts_Bitmap;	//p[cʖ{̂̃nh
HBITMAP		hBG_Bitmap;		//wiʖ{̂̃nh

HINSTANCE	hinst;		//CX^Xiɂt@Cjւ̃nh
						//QdNȂǂւ̑΍ƂĎg̃nhĂ

_Mode_stat	Mode_stat;	//Mainloop()ŎQƂtOނ܂Ƃ߂\́i` main.h QƁj

//==================================================================
//	낢
//==================================================================

//-----------------------------------
//	obNT[tFCX
//-----------------------------------

void init_Back_Surface()
{
	HDC		work_hdc;	//ƗpDC

	// obNʂ̏
	work_hdc=GetDC(hwnd);					//i\jʂDC̓e擾
	Back_DC=CreateCompatibleDC(work_hdc);	//ݒŃobNʗpDC𐶐
	hBack_Bitmap=CreateCompatibleBitmap(work_hdc,640,480);//i\jʂƓŉʐ
	SelectObject(Back_DC,hBack_Bitmap);		//DCƉʖ{̂֘At

	ReleaseDC(hwnd,work_hdc);				//ƗpDCJ
}

//-----------------------------------
//	p[cpT[tFCX
//-----------------------------------

void init_Parts_Surface()
{
	HDC		work_hdc;	//ƗpDC

	// obNʂ̏
	work_hdc=GetDC(hwnd);					//i\jʂDC̓e擾
	Parts_DC=CreateCompatibleDC(work_hdc);	//ݒŃobNʗpDC𐶐
	hParts_Bitmap=CreateCompatibleBitmap(work_hdc,75,25);//i\jʂƓŉʐ
	SelectObject(Parts_DC,hParts_Bitmap);	//DCƉʖ{̂֘At

	Load_Bmp( Parts_DC,".\\gdat\\Parts.bmp");	//p[cpBMPǂݍł

	ReleaseDC(hwnd,work_hdc);				//ƗpDCJ
}

//-----------------------------------
//	wi摜pT[tFCX
//-----------------------------------

void init_BG_Surface()
{
	HDC		work_hdc;	//ƗpDC

	// obNʂ̏
	work_hdc=GetDC(hwnd);					//i\jʂDC̓e擾
	BG_DC=CreateCompatibleDC(work_hdc);		//ݒŃobNʗpDC𐶐
	hBG_Bitmap=CreateCompatibleBitmap(work_hdc,640,480);	//i\jʂƓŉʐ
	SelectObject(BG_DC,hBG_Bitmap);			//DCƉʖ{̂֘At

	Load_Bmp( BG_DC,".\\gdat\\Back00.bmp");			//ftHgwiBMPǂݍł

	ReleaseDC(hwnd,work_hdc);				//ƗpDCJ
}


//----------------------------------
//	MainloopptOނ̏
//----------------------------------

void init_Mode_stat()
{
	Mode_stat.flag_text = ON;			//eLXg\ON
	Mode_stat.flag_delay = OFF;			//xOFF
	Mode_stat.flag_cursor_blink = OFF;	//J[\\OFF

}

//----------------------------------
//	C
//----------------------------------

void init_game()
{
	init_Back_Surface();	//Back Surface쐬
	init_Parts_Surface();	//Parts Surface쐬
	init_BG_Surface();		//BG Surface쐬

	//wiƂȂOtBbNf[^obNT[tFCXɓ]Ă
	BitBlt(Back_DC,0,0,640,480,BG_DC,0,0,SRCCOPY);	

	Init_Text_engine();		//eLXgGW

	init_Mode_stat();		//Mode_statɂ܂Ƃ߂tOނ̏
}


//==================================================================
//	C[v
//==================================================================

//bZ[Wi}EXL[̓͂ȂǁjƂɎs郋[v
void	Mainloop(void)
{
	//eLXg\
	if( Mode_stat.flag_text == ON ) Text_engine();
	
	//x
	if( Mode_stat.flag_delay == ON ) Com_delay_task();
	
	//J[\uN
	if( Mode_stat.flag_cursor_blink == ON ) Com_cursor_blink_task();

	//I
	if( Mode_stat.flag_halt == ON ) Com_halt_task();
	
	//y[W type2
	if( Mode_stat.flag_page2 == ON ) Com_page2_task();

	//ʐؑւ
	if( Mode_stat.flag_g_change == ON ) Com_g_change_task();
	


	HLS_stc_FPS(Back_DC);
	BitBlt(win_hdc,0,0,640,480,Back_DC,0,0,SRCCOPY);	//  \ʂɃRs[
}

//==================================================================
//	Cxg`FbN
//==================================================================

//bZ[Wi}EXL[̓͂Ȃǁj́AŒׂ܂
LRESULT WndProc(HWND hwnd,UINT msg,WPARAM wprm,LPARAM lprm)
{
	//̗ł́AWindowȄ{^ďI邱Ƃo܂ij
	//ɁAȂ炢낢ȃCxgǉĂ܂B

	switch(msg){
		case	WM_CREATE:		//Windowꂽ
					break;
		case	WM_DESTROY:		//Window̏삪ꂽ
					PostQuitMessage(0);
					break;
		case	WM_KEYDOWN:	//L[ꂽ
					switch(wprm){
							case	VK_ESCAPE:
								PostQuitMessage(0);
								//PostMessage(hwnd,WM_CLOSE,0,0);	//(ESC)͂ŏI
								break;
							case	VK_SPACE:
							case	VK_RETURN:
								//J[\uNȂuN
								if( Mode_stat.flag_cursor_blink == ON ){
									Com_cursor_blink_end();
								}
								//I҂ȂI
								if( Mode_stat.flag_halt == ON ){
									Com_halt_end();
								}
								//y[W̃L[҂ȂI
								if( Mode_stat.flag_page2 == ON ){
									Com_page2_end();
								}
								break;
					}
					break;
		case	WM_LBUTTONDOWN:	//}EX{^ꂽ
					//J[\uNȂuN
					if( Mode_stat.flag_cursor_blink == ON ){
						Com_cursor_blink_end();
					}
					//I҂ȂI
					if( Mode_stat.flag_halt == ON ){
						Com_halt_end();
					}
					//y[W̃L[҂ȂI
					if( Mode_stat.flag_page2 == ON ){
						Com_page2_end();
					}
					break;
		default:
			//̑̃CxgWindows̃VXeɂCiyAyj
			return DefWindowProc(hwnd,msg,wprm,lprm);	
	}

	return 0;
}


//---------------------------------------------------------
//	sJn
//---------------------------------------------------------

APIENTRY WinMain(HINSTANCE hIns,HINSTANCE hPI,LPSTR lpArg,int nCmdShow)
{
	MSG			msg;	//WindowsVXẽbZ[W\́i܂CɂȂĂłj
	WNDCLASS	wc;		//WindowNXiJƂɂgp܂j

	hinst=hIns;			//۰ٕϐ hinst ɁANɗ^ݽݽlێĂ

	//--------------------------------------------------------------
	//J߂̏vҰWindowNX wc ̃oϐɗ^
	//--------------------------------------------------------------
	wc.hInstance=hIns;					//ݽݽl
	wc.lpszClassName="P";			//NXiKł܂Ȃj
	wc.lpfnWndProc=(WNDPROC)WndProc;	//Cxgnho^
	wc.style=0;							//X^C͂Ƃ肠Oł
	wc.hIcon=LoadIcon((HINSTANCE)NULL,IDI_APPLICATION);	//ްɕ\鱲݂̫Ăł
	wc.hCursor=LoadCursor((HINSTANCE)NULL,IDC_ARROW);	//ϳقW`ł
	wc.lpszMenuName=0;					//
	wc.cbClsExtra=0;					//
	wc.cbWndExtra=0;					//
	wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	if(RegisterClass(&wc)==0)return 0;

	hwnd=CreateWindowEx(
		0,							//gX^C͓ɍlȂ
		wc.lpszClassName,			//NXiŌ߂̂^ĂOKj
		"Ƃ",					//Window̍ɕ\鑋̖O
		WS_OVERLAPPEDWINDOW,		//EBhEX^Cił͉ŵ݁j
		20,20,640,480+20,			//̔zu|WVA傫(x,yyѕA) 
		(HWND)NULL,					//eWindowفił͖j
		(HMENU)NULL,				//ƭq޳̂ŋCɂȂ
		hIns,						//CX^Xl
		(LPVOID)NULL				//ɎQƂׂf[^͖̂ŋCɂȂ
		);

	if(!hwnd)return 0;	//WindowĴɎsI
						//ٰ߂ɓOɏIƂ͂OԂKɂȂĂ

	Window_Center(hwnd);	//Windowʒɂ

	ShowWindow(hwnd,nCmdShow);	//Og̕`
	UpdateWindow(hwnd);		//NCAg̈̕`
		
	win_hdc=GetDC(hwnd);	//̉ʑɔ DC 擾Ă

	init_game();			//Q[VXe

	//JAŖ[vɓăCxgĎs
	while(1){
		//bZ[WL[ɂȂɂėH
		if(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)){
			//bZ[WΏ
			if(!GetMessage(&msg,(HWND)NULL,0,0))break;	//IbZ[WȂ烋[v
			TranslateMessage(&msg);	//L[bZ[W𕶎bZ[Wɕϊ
			DispatchMessage(&msg);	//EBhEvV[WɃbZ[W𑗕t
		}else{
			//bZ[W Mainloop()s
			Mainloop();
		}
	}

	//Iɂ wParam p[^IR[hԂKɂȂĂ
	return msg.wParam;	
}
